<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ObserverRequestProcessor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">ObserverRequestProcessor.java</span></div><h1>ObserverRequestProcessor.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.util.concurrent.LinkedBlockingQueue;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.server.RequestProcessor;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.ZooKeeperCriticalThread;
import org.apache.zookeeper.server.ZooTrace;

/**
 * This RequestProcessor forwards any requests that modify the state of the
 * system to the Leader.
 */
public class ObserverRequestProcessor extends ZooKeeperCriticalThread implements
        RequestProcessor {
<span class="fc" id="L38">    private static final Logger LOG = LoggerFactory.getLogger(ObserverRequestProcessor.class);</span>

    ObserverZooKeeperServer zks;

    RequestProcessor nextProcessor;

    // We keep a queue of requests. As requests get submitted they are 
    // stored here. The queue is drained in the run() method. 
<span class="fc" id="L46">    LinkedBlockingQueue&lt;Request&gt; queuedRequests = new LinkedBlockingQueue&lt;Request&gt;();</span>

<span class="fc" id="L48">    boolean finished = false;</span>

    /**
     * Constructor - takes an ObserverZooKeeperServer to associate with
     * and the next processor to pass requests to after we're finished. 
     * @param zks
     * @param nextProcessor
     */
    public ObserverRequestProcessor(ObserverZooKeeperServer zks,
            RequestProcessor nextProcessor) {
<span class="fc" id="L58">        super(&quot;ObserverRequestProcessor:&quot; + zks.getServerId(), zks</span>
<span class="fc" id="L59">                .getZooKeeperServerListener());</span>
<span class="fc" id="L60">        this.zks = zks;</span>
<span class="fc" id="L61">        this.nextProcessor = nextProcessor;</span>
<span class="fc" id="L62">    }</span>

    @Override
    public void run() {
        try {
<span class="pc bpc" id="L67" title="1 of 2 branches missed.">            while (!finished) {</span>
<span class="fc" id="L68">                Request request = queuedRequests.take();</span>
<span class="pc bpc" id="L69" title="1 of 2 branches missed.">                if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L70">                    ZooTrace.logRequest(LOG, ZooTrace.CLIENT_REQUEST_TRACE_MASK,</span>
                            'F', request, &quot;&quot;);
                }
<span class="fc bfc" id="L73" title="All 2 branches covered.">                if (request == Request.requestOfDeath) {</span>
<span class="fc" id="L74">                    break;</span>
                }
                // We want to queue the request to be processed before we submit
                // the request to the leader so that we are ready to receive
                // the response
<span class="fc" id="L79">                nextProcessor.processRequest(request);</span>
                
                // We now ship the request to the leader. As with all
                // other quorum operations, sync also follows this code
                // path, but different from others, we need to keep track
                // of the sync operations this Observer has pending, so we
                // add it to pendingSyncs.
<span class="fc bfc" id="L86" title="All 3 branches covered.">                switch (request.type) {</span>
                case OpCode.sync:
<span class="fc" id="L88">                    zks.pendingSyncs.add(request);</span>
<span class="fc" id="L89">                    zks.getObserver().request(request);</span>
<span class="fc" id="L90">                    break;</span>
                case OpCode.create:
                case OpCode.delete:
                case OpCode.setData:
                case OpCode.setACL:
                case OpCode.createSession:
                case OpCode.closeSession:
                case OpCode.multi:
<span class="fc" id="L98">                    zks.getObserver().request(request);</span>
                    break;
                }
<span class="fc" id="L101">            }</span>
<span class="nc" id="L102">        } catch (Exception e) {</span>
<span class="nc" id="L103">            handleException(this.getName(), e);</span>
<span class="fc" id="L104">        }</span>
<span class="fc" id="L105">        LOG.info(&quot;ObserverRequestProcessor exited loop!&quot;);</span>
<span class="fc" id="L106">    }</span>

    /**
     * Simply queue the request, which will be processed in FIFO order. 
     */
    public void processRequest(Request request) {
<span class="pc bpc" id="L112" title="1 of 2 branches missed.">        if (!finished) {</span>
<span class="fc" id="L113">            queuedRequests.add(request);</span>
        }
<span class="fc" id="L115">    }</span>

    /**
     * Shutdown the processor.
     */
    public void shutdown() {
<span class="fc" id="L121">        LOG.info(&quot;Shutting down&quot;);</span>
<span class="fc" id="L122">        finished = true;</span>
<span class="fc" id="L123">        queuedRequests.clear();</span>
<span class="fc" id="L124">        queuedRequests.add(Request.requestOfDeath);</span>
<span class="fc" id="L125">        nextProcessor.shutdown();</span>
<span class="fc" id="L126">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>